=== debian/changelog ===
libtracefs (1.0.2-1) unstable; urgency=medium

  * New upstream version 1.0.2
  * Enable verbose builds unless 'terse' DEB_BUILD_OPTIONS is set.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 15 Jan 2021 19:51:17 +0000

libtracefs (1.0.1-1) experimental; urgency=medium

  * Update watch file.
  * New upstream version 1.0.1
    - Rename package for SONAME bump.
    - Update copyright.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 10 Jan 2021 22:33:51 +0000

libtracefs (0.0~git20201221.74d7273-2) experimental; urgency=medium

  * Build and package libtracefs documentation.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 24 Dec 2020 17:16:33 +0000

libtracefs (0.0~git20201221.74d7273-1) experimental; urgency=medium

  * New upstream version 0.0~git20201221.74d7273
    - Update symbols file.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 21 Dec 2020 18:38:23 +0000

libtracefs (0.0~git20201211.ca6a929-1) experimental; urgency=medium

  * Initial release (Closes: #976425)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 11 Dec 2020 23:15:13 +0000
