=== debian/changelog ===
libtracefs (1.2.5-1) unstable; urgency=medium

  * Upload to unstable.
  * New upstream version 1.2.5
    - Update symbols.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 29 Aug 2021 23:56:07 +0100

libtracefs (1.2.0-1) experimental; urgency=medium

  * New upstream version 1.2.0
    - Remove upstream applied patch.
    - Update version dependency of libtraceevent.
    - Update symbols.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 25 May 2021 21:21:49 +0100

libtracefs (1.1.1-2) experimental; urgency=medium

  * Add version dependency on libtraceevent.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 24 Apr 2021 15:16:01 +0100

libtracefs (1.1.1-1) experimental; urgency=medium

  * New upstream version 1.1.1
    - Update copyright.
    - Update symbols file.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 24 Apr 2021 11:31:50 +0100
