=== debian/changelog ===
libtracefs (1.4.2-1) unstable; urgency=medium

  * New upstream version 1.4.2

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 22 Aug 2022 21:13:58 +0100

libtracefs (1.4.1-1) unstable; urgency=medium

  * New upstream version 1.4.1
  * Update Standards-Version to 4.6.1.0

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 09 Jul 2022 11:55:28 +0100

libtracefs (1.4.0-1) unstable; urgency=medium

  * New upstream version 1.4.0
    - Update symbols.
    - Update copyright.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 06 Jun 2022 19:55:09 +0100

libtracefs (1.3.1-1) unstable; urgency=medium

  [ Henning Schild ]
  * Update build dependencies of libtracefs.

  [ Sudip Mukherjee ]
  * New upstream version 1.3.1
  * Add bison as build dependency.
    - Thanks Felix Moessbauer.
  * Disable parallel builds. (Closes: #1008722)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 14 Apr 2022 20:23:09 +0100

libtracefs (1.3.0-1) unstable; urgency=medium

  * New upstream version 1.3.0
    - Update symbols file.
    - Remove copy before auto_test.
    - Update copyright.
  * Update Standards-Version to 4.6.0.1
  * Fix FTCBFS: Export build tools for all targets. (Closes: #1003475)
    - Thanks Helmut Grohne for the patch.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 08 Mar 2022 21:28:52 +0000
