=== debian/changelog ===
libtracefs (1.5.0-1~mx21ahs) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 17 May 2025 23:01:30 -0700

libtracefs (1.5.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 09 Oct 2022 00:13:50 +0100

libtracefs (1.5.0-1) unstable; urgency=medium

  * New upstream version 1.5.0
    - Update symbols.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 27 Sep 2022 20:32:43 +0100
