=== debian/control ===
--- 
+++ 
@@ -1,10 +1,17 @@
 Source: libtracefs
 Priority: optional
-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
-Build-Depends:
- debhelper-compat (= 13), libcunit1-dev, libtraceevent-dev (>= 1:1.3.0),
- pkg-config, asciidoc, xmlto, source-highlight
-Standards-Version: 4.5.1
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
+Build-Depends: asciidoc,
+               bison,
+               debhelper-compat (= 13),
+               flex,
+               libcunit1-dev,
+               libtraceevent-dev (>= 1:1.3.0),
+               pkgconf,
+               source-highlight,
+               xmlto
+Standards-Version: 4.6.1.0
 Section: libs
 Homepage: https://git.kernel.org/pub/scm/libs/libtrace/libtracefs.git
 Vcs-Browser: https://salsa.debian.org/sudip/libtracefs
@@ -24,7 +31,7 @@
 Package: libtracefs1
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: API to access the kernel tracefs directory (shared library)
  The libtracefs library provides APIs to access kernel tracefs file system.
  .
@@ -33,7 +40,7 @@
 Package: libtracefs-doc
 Section: doc
 Architecture: all
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: API to access the kernel tracefs directory (documentation)
  The libtracefs library provides APIs to access kernel tracefs file system.
  .
