=== debian/changelog ===
libtracefs (1.6.4-1) unstable; urgency=medium

  * New upstream version 1.6.4
  * Update Standards-Version to 4.6.2

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 17 Jan 2023 20:44:33 +0000

libtracefs (1.6.3-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Repository.
  * Apply multi-arch hints. + libtracefs-doc: Add Multi-Arch: foreign.

  [ Sudip Mukherjee ]
  * New upstream version 1.6.3 (Closes: #1025899)
    - Update symbols.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 02 Jan 2023 12:30:07 +0000
