=== debian/rules ===
--- 
+++ 
@@ -19,8 +19,3 @@
 
 override_dh_auto_install:
 	dh_auto_install -- install_doc $(build_flags)
-
-# No dbgsym packages:
-override_dh_strip:
-	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
-	dh_strip --no-automatic-dbgsym
