=== debian/changelog ===
libtracefs (1.7.0-1) unstable; urgency=medium

  [ Lucas Kanashiro ]
  * d/tests: add DEP-8 test to build samples extracted from the doc

  [ Sudip Mukherjee ]
  * New upstream version 1.7.0
    - Update copyright.
    - Add new symbols.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 24 Jun 2023 11:59:18 +0100
